require 'mongoid/semaphore'

module Mongoid
  module Lock
    extend Mongoid::Semaphore
    
    # => Volatile Access, Reload to Ensure state
    def used_by
      self.save
      self.reload
      return super
    end
    
    def self.included(base)
      base.class_eval do
        include Mongoid::Semaphore
        default_sema_count 1
        field :used_by, :type => String, :default => nil
      end
    end
  end
end

require 'mongoid/lock/synch_methods'
